# Example configuration file. Conforms with libconfig format.
#

Example = {

  # APP functionality to enable. The default state is disabled (false)
  APP = {
    Watchdog = false;
    RSATx = true;
    RSARx = true;
    #RSATx = false;
    #RSARx = false;
    RawTx = false;
    TIMGenericRx = false;
    TIMRx = false;
    OBERx = true;
    CANVState = true;
    TCClient = false;
    CANVSC3  = true;
    PosExt  = false;
  };

  RSARx = {
    # Thread wake period [ms]
    RxInterval  = 500;
  };

  RSATx = {
    # Transmit period [ms]
    TxInterval  = 500;

    # WSMP parameters
    WSMP = {
      PSID          = 0xE0525341;   # 0xE0'R''S''A'
      Priority      = 2;
      ChannelNumber = 172;
      DataRate      = 12;           # 6MBps
      TxPower       = 24;
      ExpiryTime    = 0;            # Never
    };

    # See RoadSideAlert definition in DSRC_R36_Source.ASN

    # ITIS.ITIScodes: Mandatory, Default=0xC0DA
    TypeEvent   = 0xC0DA;

    # SEQUENCE (SIZE(1..8)) OF ITIS.ITIScodes: Optional
    Description = [
                   0x0000,
                   0x0000,
                   0x0000,
                   0x0000,
                   0x0000,
                   0x0000,
                   0x0000,
                   0x0000
                  ];

    # DE_Priority: Optional
    Priority    = 0x00;

    # DE_HeadingSlice: Optional
    Heading     = 0xFFFF;

    # DE_Extent: Optional
    Extent      = 0x05;

    # DF_FullPositionVector, Optional
    Position    = [
    #               0x12345678,  # lon (overides GPS)
    #               0x87654321   # lat (overides GPS)
                  ];

    # DE_FurtherInfoID, Optional
    FurtherInfo = "50";
  };

  // Periodic transmission of a pre-defined WSM
  RawTx = {
    NotApplicable = 0;
  };

  // Dummy CSW (Curve Speed Warning)
  TIMRx = {
    # Thread wake period [ms]
    RxInterval  = 500;
  };

  // TIM Generic
  TIMGenericRx = {
    // Max Severity
    SeverityMax = 95;
    // Min Severity
    SeverityMin = 81;
    # Matching ITIS codes
    ITISCodes = [0, 0, 0, 0, 0];
  };

  CANVState = {
    # Thread wake period [ms]
    PollingInterval  = 500;
  };

  TCClient = {
    # Use defaults
  };

  /// Android HMI Configuration Section
  HMI = {
    // Forward Collision Warning has low, med, and high severity variants
    FCW =
      ({
          SeverityRange = [0, 85];
          // No icon or audio for low FCW to avoid distraction
          Icon = "/opt/cohda/application/example1609/ui/FCW/FCW_track.gif";
          Audio = "";
          Text = "Forward Collision Warning";
       },
       {
          SeverityRange = [86, 90];
          Icon = "/opt/cohda/application/example1609/ui/FCW/FCW_mid.gif";
          Audio = "/opt/cohda/application/example1609/ui/FCW/FCW.wav";
          Text = "Forward Collision Warning";
       },
       {
          SeverityRange = [91, 95];
          Icon = "/opt/cohda/application/example1609/ui/FCW/FCW_high.gif";
          Audio = "/opt/cohda/application/example1609/ui/FCW/FCW.wav";
          Text = "Forward Collision Warning";
     });
    // Emergency Electronic Brake Light
    EEBL =
      ({
          SeverityRange = [0, 255];
          Icon = "/opt/cohda/application/example1609/ui/EEBL/EEBL.gif"
          Audio = "/opt/cohda/application/example1609/ui/EEBL/EEBL.wav";
          Text = "BRAKE!";
      });
    // Intersection Collision Warning
    ICW =
      ({
          SeverityRange = [0, 50];
          // No icon or audio for low ICW to avoid distraction
          Icon = "";
          LeftIcon = "";
          RightIcon = "";
          Audio = "";
          LeftAudio = "";
          RightAudio = "";
          // Cohda ICW expects a %s placeholder for direction of ICW
          Text = "Oncoming %s Vehicle";
       },
       {
          SeverityRange = [51, 255];
          // CSW and ICW have left and right directional icons
          Icon = "/opt/cohda/application/example1609/ui/dvi/red_wrnga.png";
          LeftIcon = "/opt/cohda/application/example1609/ui/dvi/icw_left.png";
          RightIcon = "/opt/cohda/application/example1609/ui/dvi/icw_right.png";
          Audio = "/opt/cohda/application/example1609/ui/dvi/highbeep.wav";
          LeftAudio = "/opt/cohda/application/example1609/ui/dvi/highbeep.wav";
          RightAudio = "/opt/cohda/application/example1609/ui/dvi/highbeep.wav";
          // Cohda ICW expects a %s placeholder for direction of ICW
          Text = "Oncoming %s Vehicle";
       });
    // Curve Speed Warning
    CSW =
      ({
          SeverityRange = [0, 125];
          // CSW and ICW have left and right directional icons but can
          // also have just Icon if no direction available
          Icon = "/opt/cohda/application/example1609/ui/dvi/csw_left_low.png";
          LeftIcon = "/opt/cohda/application/example1609/ui/dvi/csw_left_low.png";
          RightIcon = "/opt/cohda/application/example1609/ui/dvi/csw_right_low.png";
          Audio = "";
          LeftAudio = "";
          RightAudio = "";
          // Cohda CSW expects a %s placeholder for curve direction and
          // a %u placeholder for curve speed
          Text = "%ukm/h %s Curve Ahead";
       },
       {
          SeverityRange = [126, 255];
          // CSW and ICW have left and right directional icons but can
          // also have just Icon if no direction available
          Icon = "/opt/cohda/application/example1609/ui/dvi/csw_left_high.png";
          LeftIcon = "/opt/cohda/application/example1609/ui/dvi/csw_left_high.png";
          RightIcon = "/opt/cohda/application/example1609/ui/dvi/csw_right_high.png";
          Audio = "/opt/cohda/application/example1609/ui/dvi/lowbeep.wav";
          LeftAudio = "/opt/cohda/application/example1609/ui/dvi/lowbeep.wav";
          RightAudio = "/opt/cohda/application/example1609/ui/dvi/lowbeep.wav";
          // Cohda CSW expects a %s placeholder for curve direction and
          // a %u placeholder for curve speed
          Text = "Over Speed %ukm/h on %s Curve";
      });
    Custom =
      ({
          SeverityRange = [0, 255];
          ITIS = 5912; // wet-and-icy-roads
          Icon = "/opt/cohda/application/example1609/ui/dvi/ice.gif";
          Audio = "/opt/cohda/application/example1609/ui/dvi/ice.wav";
          Text = "Icy Road Ahead";
      });
    // SVA
    SVA =
      ({
          SeverityRange = [0, 255];
          Icon = "/opt/cohda/application/example1609/ui/Other/Other.png"
          Audio = "/opt/cohda/application/example1609/ui/ping.wav";
          Text = ""; // Use dynamic test
      });
    // LCW
    LCW =
      ({
          SeverityRange = [0, 255];
          Icon = "/opt/cohda/application/example1609/ui/LCW/LCW.png"
          Audio = "/opt/cohda/application/example1609/ui/ping.wav";
          Text = "Lane Change Warning";
      });
    // DNPW
    DNPW =
      ({
          SeverityRange = [0, 255];
          Icon = "/opt/cohda/application/example1609/ui/DNPW/DNPW.png"
          Audio = "/opt/cohda/application/example1609/ui/ping.wav";
          Text = "Do not pass";
      });
    // LTA
    LTA =
      ({
          SeverityRange = [0, 255];
          Icon = "/opt/cohda/application/example1609/ui/Other/Other.png"
          Audio = "/opt/cohda/application/example1609/ui/dvi/highbeep.wav";
          Text = ""; // Use dynamic text
      });
    // HLW
    HLW =
      ({
          SeverityRange = [0, 190];
          Icon = "/opt/cohda/application/example1609/ui/Other/Other.png"
          Audio = "/opt/cohda/application/example1609/ui/Other/Other.wav";
          Text = "Warning";
      });
    // EVW
    EVW =
      ({
          SeverityRange = [50, 255];
          Icon = "/opt/cohda/application/example1609/ui/EVW/EVW.png"
          Audio = "/opt/cohda/application/example1609/ui/EVW/EVW.wav";
          Text = ""; // Use dynamic text
      });
    // SVW
    SVW =
      ({
          SeverityRange = [50, 255];
          Icon = "/opt/cohda/application/example1609/ui/RLW/EVW.png"
          Audio = "/opt/cohda/application/example1609/ui/FCW/FCW.wav";
          Text = "STOP!";
      });
    // GREEN_PHASE
    GREEN_PHASE =
      ({
          SeverityRange = [50, 250];
          Icon = "/opt/cohda/application/example1609/ui/GLOSA/GLOSA_Green.png"
          Audio = "";
          Text = "";
      });
    // YELLOW_PHASE
    YELLOW_PHASE =
      ({
          SeverityRange = [50, 250];
          Icon = "/opt/cohda/application/example1609/ui/GLOSA/GLOSA_Yellow.png"
          Audio = "";
          Text = "";
      });
    // RED_PHASE
    RED_PHASE =
      ({
          SeverityRange = [50, 250];
          Icon = "/opt/cohda/application/example1609/ui/GLOSA/GLOSA_Red.png"
          Audio = "";
          Text = "";
      });
    // RWW
    RWW =
      ({
          SeverityRange = [0, 190];
          Icon = "/opt/cohda/application/example1609/ui/RWW/RWW.png"
          Audio = "/opt/cohda/application/example1609/ui/ping.wav";
          Text = "Roadwork";
      });
    }
};
